#============================================================
#   m0*0* Script version 2.6 Copyright  1999 marky.
#------------------------------------------------------------
#                Development started 03/09/99
#------------------------------------------------------------
#               Don't fuck with the script :]
#============================================================

#  05/09/99     Initial Release
#               Completely rewrote from original moo_com.tcl
#               to cope with a botnet and hopefully limitless
#               other bots running the script.
#               From this point it should be much easier to 
#               expand upon as the existing linking procedure
#               is faily sturdy
#  07/09/99     Fixed TCL errors caused by manipulation of
#               variables which contained "'s and also made
#               public commands handler strip all control codes
#  22/09/99     Fixed lots of bugs, made it more streamlined
#               code is much tidier (in places:)
#               Added: ban/undo/redo/moohelp
#               Will soon add: unban :P
#  23/09/99     *parp* done lots of stuff again
#               help system should work, auth adds your host 
#               if it isnt on your list, added ability of chan
#               flagged peeps e.g chan owners to make masters,
#               etc via msging commands.
#               Use moohelp to get a full feature list
#
#  26/09/99     
#               

#               TODO: (really really need to do)
#               -_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
#               Show list of bans placed with "ban" public 
#               command and allow modification of the list
#               via unban command or something...
#               ---------------------------------------------
#
#               TODO: (other stuff)
#               -_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-
#               Put ICQ msg back in?
#               ---------------------------------------------
#               Welcome message for channels
#               ---------------------------------------------
#

#============================================================
# Global Variables
#============================================================

set moovar_ValidPubCommands [list "op" "deop" "voice" "devoice" "kick" "ban" "undo" "redo"]
set moovar_admins "marky mrbusy giant"
set moo_debugging 0
set moovar_searching 0
set moovar_cownum 0
set moovar_sync 0
set moo_scriptver "v2.51"
set moo_scriptdate "23rd September 1999"
set moo_scriptcomment "by Marky"
set moovar_mychans ""

# Initialisation timer to resync :)

utimer 1 {
put_moolog "Moo Script initialised, I'm gonna moo really loudly now!"
moo_resync self script_init moo_script args
}

#============================================================
# Binds
#============================================================

bind bot - moo moobot_othersearching
bind bot - moo! moobot_foundothers
bind bot - channel_list moobot_channellist
bind bot - channels_watching moobot_channelwatch
bind bot - add_controlchan moobot_addchans
bind bot - donesync moobot_donesync
bind bot - addauth moobot_addauth

bind pubm - * moo_pubeventhandler

bind msg - auth moo_authhandler
bind msg n| moosync moo_resync
bind msg - moohelp moo_msg_help
bind msg - forgotpass moo_msg_forgotpass

bind msg - whoami moo_whoami
bind msg n|n +chanmaster moo_chan_addmaster
bind msg n|n -chanmaster moo_chan_delmaster
bind msg m|m +chanop moo_chan_addoper
bind msg m|m -chanop moo_chan_deloper
bind msg o|o +chanvoice moo_chan_addvoice
bind msg o|o -chanvoice moo_chan_delvoice

#============================================================
# Procedures and Functions
#============================================================

##############################################################################
proc moo_chan_addvoice {nick uhost hand rest} {
   if {![moo_validchange $nick [lindex $rest 0] [lindex $rest 1] [lindex $rest 2] +CHANVOICE]} {return 0}
   moo_flagchange $nick |+v [lindex $rest 1] [lindex $rest 2] [lindex $rest 0]
}
##############################################################################
proc moo_chan_delvoice {nick uhost hand rest} {
   if {![moo_validchange $nick [lindex $rest 0] [lindex $rest 1] [lindex $rest 2] -CHANVOICE]} {return 0}
   moo_flagchange $nick |-v [lindex $rest 1] [lindex $rest 2] [lindex $rest 0]
}
##############################################################################
proc moo_chan_addoper {nick uhost hand rest} {
   if {![moo_validchange $nick [lindex $rest 0] [lindex $rest 1] [lindex $rest 2] +CHANOP]} {return 0}
   moo_flagchange $nick |+o [lindex $rest 1] [lindex $rest 2] [lindex $rest 0]
}
##############################################################################
proc moo_chan_deloper {nick uhost hand rest} {
   if {![moo_validchange $nick [lindex $rest 0] [lindex $rest 1] [lindex $rest 2] -CHANOP]} {return 0}
   moo_flagchange $nick |-o [lindex $rest 1] [lindex $rest 2] [lindex $rest 0]
}
##############################################################################
proc moo_chan_addmaster {nick uhost hand rest} {
   if {![moo_validchange $nick [lindex $rest 0] [lindex $rest 1] [lindex $rest 2] +CHANMASTER]} {return 0}
   moo_flagchange $nick |+m [lindex $rest 1] [lindex $rest 2] [lindex $rest 0]
}
##############################################################################
proc moo_chan_delmaster {nick uhost hand rest} {
   if {![moo_validchange $nick [lindex $rest 0] [lindex $rest 1] [lindex $rest 2] -CHANMASTER]} {return 0}
   moo_flagchange $nick |-m [lindex $rest 1] [lindex $rest 2] [lindex $rest 0]
}


##############################################################################

proc moo_validchange {nick _chan _nick _hand commandname} {

global botnick

   if {($_chan=="")||($_nick=="")||($_hand=="")} {
   err $nick "Correct syntax is /msg $botnick $commandname <channel> <nick> <UserID>"
   fastnotice $nick "UserID is a unique handle for the user. For example the UserID of (King)Ding could be 'ding'"
   return 0
   }

   set tmp_validchan 0

   foreach chan [channels] {
      if {[string tolower $_chan]==[string tolower $chan]} {set tmp_validchan 1}
   }

   if {!$tmp_validchan} {err $nick "Invalid channel specified"
   return 0
   }

   if {![onchan $_nick $_chan]} {err $nick "$_nick isn't on $_chan"
   return 0
   }

   if {[string length $_hand] >8} {err $nick "UserID is too long, 8 chars max"
   return 0
   }

   if {([validuser $_hand])&&([string tolower [nick2hand $_nick $_chan]]!=[string tolower $_hand])} {
   fastnotice $nick "The UserID already exists and doesn't seem to be $_nick"
   fastnotice $nick "If it is the UserID of $_nick they must auth before you can perform this command"
   return 0 
   }

   if {[nick2hand $_nick $_chan]!="*"} {
      if {[string tolower [nick2hand $_nick $_chan]]!=[string tolower $_hand]} {
         err $nick "$_nick already has a UserID ([nick2hand $_nick $_chan])"
         return 0
      }
   }

   # Check that the guy actually has ops on the chan, or globally (hence the "o|o")

   set tmp_cmd [string range $commandname 1 end]
   set hand [nick2hand $nick]

   if {$tmp_cmd == "CHANOP"} {
      if {([matchattr $hand m|m $_chan])||([matchattr $hand n|n $_chan])} {
         return 1
      } else {
         err $nick "Nice try :)"
         return 0
      }
   }

   if {$tmp_cmd == "CHANVOICE"} {
      if {([matchattr $hand m|m $_chan])||([matchattr $hand n|n $_chan])||([matchattr $hand o|o $_chan])} {
         return 1
      } else {
         err $nick "Nice try :)"
         return 0
      }
   }

   if {$tmp_cmd == "CHANMASTER"} {
      if {([matchattr $hand n|n $_chan])} {
         return 1
      } else {
         err $nick "Nice try :)"
         return 0
      }
   }

   return 1

}


##############################################################################

proc moo_flagchange {nick change _nick _hand _chan} {

global botnick
   
   set globflag 1
   if {[string range $change 0 0]=="|"} {set globflag 0}
   
   set _wasnew 0

   if {![validuser $_hand]} {
      set _wasnew 1
      set _host [getchanhost $_nick $_chan]
      set _hostmask [string tolower "*$_nick*![string range $_host [string first "!" $_host] [string first "@" $_host]]*"]   
      adduser $_hand $_hostmask
      put_moolog "<<USERFILE>> User added by $nick: $_nick ($_hand)"
   }

   if {$globflag} {chattr $_hand $change} else {chattr $_hand $change $_chan}
   if {$globflag} {suc $nick "$change for $_nick ($_hand)"
      put_moolog "<<USERFILE>> Flag change by $nick: $_nick ($_hand) $change (global)"} else {
      put_moolog "<<USERFILE>> Flag change by $nick: $_nick ($_hand) $change on $_chan"
      suc $nick "[string range $change 1 end] for $_nick ($_hand) on $_chan"
   }

   # Don't notify if a flag was REMOVED;)

   if {([string range $change 1 1]=="-")||([string range $change 0 0]=="-")} {return}

   if {$_wasnew} {
      if {$globflag} {
      slownotice $_nick "Hi! You've just been added to my userlist by \002$nick\002"
      slownotice $_nick "You have been given \002$change\002. Your UserID is \002$_hand\002"
      slownotice $_nick "You need a password: /msg $botnick PASS <password>"
      slownotice $_nick "To see the commands available to you /msg $botnick MOOHELP" } else {
      slownotice $_nick "Hi! You've just been added to my userlist by \002$nick\002"
      slownotice $_nick "You have been given \002[string range $change 1 end]\002 on \002$_chan\002. Your UserID is \002$_hand\002"
      slownotice $_nick "You need a password: /msg $botnick PASS <password>"
      slownotice $_nick "To see the commands available to you /msg $botnick MOOHELP"
      }
   } else {
      if {$globflag} {
      slownotice $_nick "Hi! You've just been given \002$change\002 by $nick."
      slownotice $_nick "To see the commands available to you /msg $botnick MOOHELP" } else {
      slownotice $_nick "Hi! You've just been given \002[string range $change 1 end]\002 on \002$_chan\002 by $nick."
      slownotice $_nick "To see the commands available to you /msg $botnick MOOHELP"
      }
   }

}

##############################################################################

proc moo_pubeventhandler {nick uhost hand chan rest} {
# Procedure executed to catch public commands

   global moovar_ValidPubCommands moovar_AuthedUser botnick moovar_sync moovar_mychans 

   # Quickly exit if user is a peon.
   if {$hand == "*"} {return 0}
   put_debug "Entering pub event handler"

   # Convert handle to lowercase, for ease of use 
   set hand [string tolower $hand]
   
   # Strip control codes and "'s :) (the dittos were causing a nasty tcl error)
   # " = 22 in hex which = 42 in octal
   put_debug "Cleaning string"
   if {[info exists finaltext]} {unset finaltext}
   append tmp_text $rest

   for {set x 0} {$x<=[string length $tmp_text]} {incr x} { 
      if {("[string index $tmp_text $x]" != "\042") && ("[string index $tmp_text $x]" != "\001") && ("[string index $tmp_text $x]" != "\002") && ("[string index $tmp_text $x]" != "\003") && ("[string index $tmp_text $x]" != "\037")} {
         append finaltext [string index $tmp_text $x] 
      }
   }  

   set rest [split $finaltext " "]
   set tmp_command [string tolower [lindex $rest 0]]

# Catch ONLY commands ;)
   if {[lsearch -exact $moovar_ValidPubCommands $tmp_command] == -1} {return 0}
   put_debug "Valid command was entered"
# Check that Bot(s) are synched
   if {$moovar_sync <4} {
      err $nick "Bot(s) are currently desynched.  Sync lev ($moovar_sync)."
      put_moolog "Public commands requested but Bot is currently desynched!"
      return 0
   }
   put_debug "Bots are synched"
# Check the bot controls the channel

  if {[lsearch -exact $moovar_mychans $chan] == -1} {return 0}

# User is known, now check that they have authed!
   put_debug "Begin auth check"
   if {[info exists moovar_AuthedUser($hand)]} {
      put_debug "Variable exists...."
      if {[lindex $moovar_AuthedUser($hand) 0] == "0"} {
         put_debug "Authed variable is 0"
         err $nick "($hand) - You must auth!"
         putserv "NOTICE $nick :You can do this via /msg $botnick AUTH <userid> <password>"
         return 0 
      }
   } else {
      put_debug "Variable not found in array"
      err $nick "($hand) - You must auth!"
      putserv "NOTICE $nick :You can do this via /msg $botnick AUTH <userid> <password>"
      return 0
   }

# Users ID is actually authed.... make sure they're using the same ident/ip as when they authed


   put_debug "User is authed, checking hostmask"

if {[lindex $moovar_AuthedUser($hand) 1] != [string tolower "*![string range $uhost [string first "!" $uhost] end]"]} {
put_debug "Hostmask changed"
err $nick "You must auth!"
putserv "NOTICE $nick :You can do this via /msg $botnick AUTH <userid> <password>"
return 0
}

put_debug "Auth check finished, they're ok."
if {$tmp_command == "op"} {moo_modechange $nick $uhost $hand $chan +o [lindex $rest 1]}
if {$tmp_command == "deop"} {moo_modechange $nick $uhost $hand $chan -o [lindex $rest 1]}
if {$tmp_command == "voice"} {moo_modechange $nick $uhost $hand $chan +v [lindex $rest 1]}
if {$tmp_command == "devoice"} {moo_modechange $nick $uhost $hand $chan -v [lindex $rest 1]}
if {$tmp_command == "kick"} {kick_user $nick $uhost $hand $chan [string range $rest 4 end]}
if {$tmp_command == "ban"} {ban_user $nick $uhost $hand $chan [string range $rest 3 end]}
if {$tmp_command == "undo"} {undo $nick $chan}
if {$tmp_command == "redo"} {redo $nick $chan}

}
##############################################################################

proc moo_msg_help {nick uhost hand rest} {

# Procedure executed to catch msg'd commands

   global moo_scriptver moo_scriptdate moo_scriptcomment botnick moovar_AuthedUser

   puthelp "NOTICE $nick :\002m0*0* Script $moo_scriptver $moo_scriptdate $moo_scriptcomment\002"
   puthelp "NOTICE $nick : "

   if {$hand == "*"} {
      puthelp "NOTICE $nick :Hi \002$nick\002, I don't know who you are"
      puthelp "NOTICE $nick : "
      puthelp "NOTICE $nick :You must auth!"
      puthelp "NOTICE $nick :You can do this via /msg $botnick AUTH <userid> <password>"
      return 0
   } else {
      set hand [string tolower $hand]
      puthelp "NOTICE $nick :Hi \002$nick\002, I think your UserID is $hand"
      puthelp "NOTICE $nick : "
      if {[info exists moovar_AuthedUser($hand)]} {
         if {[lindex $moovar_AuthedUser($hand) 0] == "0"} {
         puthelp "NOTICE $nick :($hand) - You must auth! ~auths reset"
         puthelp "NOTICE $nick :You can do this via /msg $botnick AUTH <userid> <password>"
         return 0 
         }
         if {[lindex $moovar_AuthedUser($hand) 1] != [string tolower "*![string range $uhost [string first "!" $uhost] end]"]} {
         puthelp "NOTICE $nick :($hand) - You must auth! ~hostmask changed"
         puthelp "NOTICE $nick :You can do this via /msg $botnick AUTH <userid> <password>"
         return 0
         }
      } else {
         puthelp "NOTICE $nick :($hand) - You must auth! ~no last auth found"
         puthelp "NOTICE $nick :You can do this via /msg $botnick AUTH <userid> <password>"
         return 0 
      }
   }

   puthelp "NOTICE $nick :\037Public Commands\037 (said on the channel)"
   puthelp "NOTICE $nick :\002op/deop\002 <me/nick>"
   puthelp "NOTICE $nick :Performs the change you specified on you or <nick> (+o)"
   puthelp "NOTICE $nick :\002voice/devoice\002 <me/nick>"
   puthelp "NOTICE $nick :Performs the change you specified on you or <nick> (+v)"
   puthelp "NOTICE $nick :\002kick/ban\002 <nick>"
   puthelp "NOTICE $nick :Either kicks or bans <nick> (+o)"
   puthelp "NOTICE $nick :\002undo/redo\002"
   puthelp "NOTICE $nick :undo or redo last ban placed by me (+o)"
   puthelp "NOTICE $nick :"
   puthelp "NOTICE $nick :\037MSG Commands\037 (said to me via /msg)"
   puthelp "NOTICE $nick :\002auth\002 <userid> <password>"
   puthelp "NOTICE $nick :Authorises you to use commands available to you"
   puthelp "NOTICE $nick :\002whoami\002"
   puthelp "NOTICE $nick :Tells you who I think you are and what flags you have"
   puthelp "NOTICE $nick :"
   puthelp "NOTICE $nick :\002+chanvoice/-chanvoice\002 <channel> <nick> <userid>"
   puthelp "NOTICE $nick :Adds <nick> as a +v on <channel>"
   puthelp "NOTICE $nick :\002+chanop/-chanop\002 <channel> <nick> <userid>"
   puthelp "NOTICE $nick :Adds <nick> as a +o on <channel>"
   puthelp "NOTICE $nick :\002+chanmaster/-chanmaster\002 <channel> <nick> <userid>"
   puthelp "NOTICE $nick :Adds <nick> as a +m on <channel>"
   puthelp "NOTICE $nick :"
   puthelp "NOTICE $nick :\002Note\002: Flags in brackets above mean you need this flag on the channel you want to change the users flags on.  To view your flags: /msg $botnick whoami"

}
##############################################################################

proc moo_whoami {nick uhost hand rest} {

   if {$hand == "*"} {
      slownotice $nick "You look like a bit of a peon to me..."
      return 0
   }

   slownotice $nick "I know you! I've seen you before..."
   slownotice $nick "You're $nick ($uhost) and your UserID is $hand"
   slownotice $nick ""

   if {[matchattr $hand n]} {slownotice $nick "Global Flags: Owner"
   } elseif {[matchattr $hand m]} {slownotice $nick "Global Flags: Master" 
   } elseif {[matchattr $hand o]} {slownotice $nick "Global Flags: Operator"
   } elseif {[matchattr $hand v]} {slownotice $nick "Global Flags: Voice"
   } else {slownotice $nick "Global Flags: Peon"
   }
   slownotice $nick "Channel Flags:"

   foreach chan [channels] {
      if {[matchattr $hand |n $chan]} {slownotice $nick "   $chan: Owner"
      } elseif {[matchattr $hand |m $chan]} {slownotice $nick "   $chan: Master" 
      } elseif {[matchattr $hand |o $chan]} {slownotice $nick "   $chan: Operator"
      } elseif {[matchattr $hand |v $chan]} {slownotice $nick "   $chan: Voice"
      }
   }

}

##############################################################################

proc moo_msg_forgotpass {nick uhost hand rest} {
   
   global moovar_admins

   puthelp "NOTICE $nick :Admins have been informed."
   foreach admin $moovar_admins {
   sendnote $nick $admin "Hehe! I seem to have \002forgot my password\002 because I'm a stupid peon (my user id seems to be $hand)"
   }
   
   
}
##############################################################################
proc moo_clearauths {} {

global moovar_AuthedUser

foreach knownuser [userlist] {
set moovar_AuthedUser($knownuser) [list "0" "*"]
}
}

##############################################################################

proc moo_startsearch {} {
# Search for others running moo_script
   global moovar_searching moovar_cownum moovar_cows botnick

   set moovar_searching 1
   set moovar_cownum 0
   # The star below denotes Master Bot status
   set moovar_cows(0) $botnick
   putallbots "moo"
   utimer 2 {moobot_sortcows}
   put_moolog "Sync in progress (I moo'ed really loudly)"
}
##############################################################################


proc moobot_sortcows {} {
# Cows have been found, put them in order!
   global moovar_cownum moovar_cows moovar_cowchans

put_moolog "Stopped searching for cows, sorting the heard (found: $moovar_cownum)"

# First clear all chans they are supposed to be watching

   for {set cnt 1} {$cnt <=$moovar_cownum} {incr cnt} {
      set moovar_cowchans($cnt) ""
   }

# Request lists from all cows

   for {set x 0} {$x <= $moovar_cownum} {incr x} {
      if {$x == 0} {
         put_moolog "Master: $moovar_cows(0)" 
 
         foreach chan [channels] {
             lappend tmp_chanlist $chan
         }

         set moovar_cowchans(0) $tmp_chanlist
         put_moolog "I am watching $moovar_cowchans(0)"
         unset tmp_chanlist
      } else {
         lappend tmp_ask "channel_list" $x
         putbot $moovar_cows($x) $tmp_ask
         unset tmp_ask
      }
   }

   #Quick check too see if all lists have arrived...

   moo_checkallsent

}

##############################################################################


proc moobot_channellist {bot cmd arg} {
# Channels requested, sending them

   lappend tmp_chanlist "channels_watching"
   put_moolog "$bot said I am cow number $arg"
   lappend tmp_chanlist $arg

   foreach chan [channels] {
      lappend tmp_chanlist $chan
   }

   lappend tmp_chanlist "*"
   put_moolog $tmp_chanlist
   putbot $bot $tmp_chanlist
   unset tmp_chanlist

}

##############################################################################


proc moobot_channelwatch {bot cmd arg} {
# Channels received
global moovar_cownum moovar_sync moovar_cowchans

   put_moolog "$bot ([lindex $arg 0]) just sent me a chan list"

# Tidy up the list

   set tmp_cownum [lindex $arg 0]
   set tmp_argnum 1

   for {set carryon 0} {$carryon<1} {} {
      if {[lindex $arg $tmp_argnum] != "*"} {
         lappend tmp_clist [lindex $arg $tmp_argnum]
         incr tmp_argnum } else {
         set carryon 1}
   }


# above bit keeps adding the chans until the * is found, otherwise it continues forever and 
# will stay in an infinite loop, lets hope this doesnt happen (it shouldnt)

   set moovar_cowchans($tmp_cownum) $tmp_clist
   put_moolog "$bot is watching $moovar_cowchans($tmp_cownum)"

# Check if all bots have sent their lists
   unset tmp_cownum
   unset tmp_argnum
   unset carryon
   moo_checkallsent

}

##############################################################################

proc moo_checkallsent {} {

# Check if all bots have sent their lists

global moovar_cownum moovar_sync moovar_cowchans moovar_chanlist moovar_chancount moovar_cows
   
   set moovar_sync 2

   for {set cnt 1} {$cnt <=$moovar_cownum} {incr cnt} {
      if {$moovar_cowchans($cnt) == ""} {set moovar_sync 1}
   }

   if {$moovar_sync==2} {

      put_moolog "All Cows have sent lists...processing."

# Make a list of all channels monitored, set the fastest bot to be the
# one that runs that channel...MAYBE I will do a queue system so if one
# bot is busy another on the chan another will process...BUT it doesnt take THAT
# long to process a command....

      for {set cnt 0} {$cnt <=20} {incr cnt} {
         if {[lindex $moovar_cowchans(0) $cnt] != ""} {
            lappend tmp_fulllist [lindex $moovar_cowchans(0) $cnt]} else {
            set tmp_totalchancnt $cnt
            set cnt 20}
      }

# Check for up to 20 channels on each bot, adding to the list of unique channels

      for {set cowcnt 1} {$cowcnt <= $moovar_cownum} {incr cowcnt} {
         for {set cnt 0} {$cnt <=20} {incr cnt} {
            if {[lindex $moovar_cowchans($cowcnt) $cnt] != ""} {
             
              if {[lsearch -exact $tmp_fulllist [lindex $moovar_cowchans($cowcnt) $cnt]] == -1} {
                  lappend tmp_fulllist [lindex $moovar_cowchans($cowcnt) $cnt]
                  incr tmp_totalchancnt } else {
              }
  
            } else {set cnt 20}
         }
      }

      put_moolog "Total Channel Count Now: ($tmp_totalchancnt)"
      put_moolog "Channels: $tmp_fulllist"

# end of the for for all the cows, clean it up...

      set moovar_chanlist $tmp_fulllist
      set moovar_chancount $tmp_totalchancnt
      
      set moovar_searching 0

      unset tmp_fulllist
      unset tmp_totalchancnt
      unset cowcnt
      unset cnt

      moobot_selectbots

   }

}
##############################################################################
proc moobot_selectbots {} {

global moovar_cownum moovar_sync moovar_cowchans moovar_chanlist moovar_chancount moovar_cows botnick moovar_mychans

   put_moolog "Selecting the ControlCows"

   for {set reps 0} {$reps < $moovar_chancount} {incr reps} {
      set tmp_donechan 0

      for {set botreps 0} {$tmp_donechan != 1} {incr botreps} {
         if {[moobot_botonchan $botreps [lindex $moovar_chanlist $reps]] == 1} {
            set moovar_controlbot([lindex $moovar_chanlist $reps]) $moovar_cows($botreps)
            put_moolog "ControlCow for [lindex $moovar_chanlist $reps] : $moovar_cows($botreps)"
            set tmp_donechan 1
         }
         if {($botreps == $moovar_cownum) && ($tmp_donechan == 0)} {
            put_moolog "WARNING: No Bot to control [lindex $moovar_chanlist $reps] (this should never happen)"
            set tmp_donechan 1
         }
      }  

   }

   put_moolog "Sending lists out"

   for {set reps 0} {$reps <$moovar_chancount} {incr reps} {
      if {[string tolower $botnick] == [string tolower $moovar_controlbot([lindex $moovar_chanlist $reps])]} {
          lappend moovar_mychans [lindex $moovar_chanlist $reps]    
      } else {
      putbot $moovar_controlbot([lindex $moovar_chanlist $reps]) "add_controlchan [lindex $moovar_chanlist $reps]"
      }
   }

   put_moolog "My channels: $moovar_mychans"

   for {set botreps 1} {$botreps<=$moovar_cownum} {incr botreps} {
   putbot $moovar_cows($botreps) "donesync"
   }

   put_moolog "Sync Complete"
   set moovar_sync 4

}

##############################################################################
proc moobot_botonchan {botnum channame} {
global moovar_cownum moovar_sync moovar_cowchans moovar_chanlist moovar_chancount moovar_cows

   set tmp_result 0

   for {set chanreps 0} {$chanreps <$moovar_chancount} {incr chanreps} {
     if {[lindex $moovar_cowchans($botnum) $chanreps] == $channame} {set tmp_result 1}
   }

   if {$tmp_result==1} {
   unset tmp_result
   return 1
   }

   unset tmp_result
   return 0

}

##############################################################################
proc moobot_othersearching {bot cmd arg} {
# Another bot has began a search
   global moovar_sync moovar_searching moovar_cownum moovar_mychans moovar_AuthedUser

set moovar_searching 0
set moovar_cownum 0
set moovar_mychans ""

   set moovar_sync 1
   putbot $bot "moo!"
   put_moolog "Sync in progress (replied to a moo)"

}
##############################################################################
proc moobot_addchans {bot cmd arg} {
# Add channels to the ones which the bot controls
   global moovar_mychans
   lappend moovar_mychans $arg
}
##############################################################################
proc moobot_donesync {bot cmd arg} {
# Add channels to the ones which the bot controls
   global moovar_mychans moovar_sync
   put_moolog "I now control $moovar_mychans"
   put_moolog "Sync Complete"
   set moovar_sync 4

}
##############################################################################

proc moobot_foundothers {bot cmd arg} {
# Bot has replied to a moo

   global  moovar_cows moovar_searching moovar_cownum
   
   if {$moovar_searching == 1} {
   incr moovar_cownum
   put_moolog "Sync in progress (found cow ($moovar_cownum) $bot)"
   set moovar_cows($moovar_cownum) $bot
   }
}
##############################################################################

proc moobot_addauth {bot cmd arg} {
# A Bot has authed a user

   global  moovar_AuthedUser

set tmp_anick [lindex $arg 0]
set tmp_ahand [lindex $arg 1]
set tmp_ahost [lindex $arg 2]


   set moovar_AuthedUser($tmp_ahand) [list 1 $tmp_ahost]
   put_moolog "AUTH success ($tmp_anick) as ($tmp_ahand @ $tmp_ahost) by ($bot)"

unset tmp_anick
unset tmp_ahand
unset tmp_ahost

}

##############################################################################

proc moo_resync {nick uhost hand args} {
# Execute moo_startsearch procedure

global moovar_sync moovar_searching moovar_cownum moovar_mychans moovar_AuthedUser

   set moovar_sync 1
   set moovar_searching 0
   set moovar_cownum 0
   set moovar_mychans ""

   put_moolog "Resync requested: $hand ($uhost)"
   moo_startsearch

}
##############################################################################

proc err {nick errormsg} {
putserv "NOTICE $nick :\002Error:\002 $errormsg"
}
##############################################################################

proc suc {nick sucmsg} {
putserv "NOTICE $nick :\002Sucess:\002 $sucmsg"
}

##############################################################################
proc slownotice {nick tmp_notice} {
puthelp "NOTICE $nick :$tmp_notice"
}
##############################################################################
proc fastnotice {nick tmp_notice} {
putserv "NOTICE $nick :$tmp_notice"
}
##############################################################################

proc moo_authhandler {nick uhost hand rest} {
# Procedure catch and process auth requests

   global moovar_AuthedUser botnick

   set tmp_AuthHand [string tolower [lindex $rest 0]]
   set tmp_AuthPass [lindex $rest 1]
   set tmp_AuthMask [string tolower "*![string range $uhost [string first "!" $uhost] end]"] 
   set tmp_UserHostMask [string tolower "*$nick*![string range $uhost [string first "!" $uhost] [string first "@" $uhost]]*"]   

   if {$rest ==""} {
      err $nick "Correct syntax is /msg $botnick AUTH <userid> <password>"
      put_moolog "AUTH failure ($nick) as ($tmp_AuthHand) (wrong syntax)"
      return 0
   }

   set tmp_validhandle 0

   foreach knownuser [userlist] {
      if {[string tolower $knownuser] == [string tolower $tmp_AuthHand]} {set tmp_validhandle 1}
   }

   if {$tmp_validhandle == 0} {
      err $nick "Access Denied - Unknown UserID."
      unset tmp_validhandle
      return 0
   }

   if {![passwdok $tmp_AuthHand $tmp_AuthPass]} {
      err $nick "Access Denied - Incorrect Password."
      putserv "NOTICE $nick :Forgot password? /msg $botnick FORGOTPASS"
      put_moolog "AUTH failure ($tmp_AuthHand) as ($tmp_AuthHand) (wrong password)"
      return 0
   }


   if {[string tolower [finduser $tmp_UserHostMask]]!=[string tolower $tmp_AuthHand]} {
      err $nick "Your host doesn't match any I know, adding your current host to my database..."
      put_moolog "AUTH $nick - Adding new host to $tmp_AuthHand ($tmp_UserHostMask)"
      setuser $tmp_AuthHand HOSTS $tmp_UserHostMask
   }

   putallbots "addauth $nick $tmp_AuthHand $tmp_AuthMask"
   set moovar_AuthedUser($tmp_AuthHand) [list 1 $tmp_AuthMask]
   put_moolog "AUTH success ($nick) as ($tmp_AuthHand @ $tmp_AuthMask)"
   suc $nick "AUTH'd as $tmp_AuthHand ($tmp_AuthMask)"

   unset tmp_AuthHand
   unset tmp_AuthPass
   unset tmp_AuthMask
   unset tmp_UserHostMask

}
##############################################################################

proc put_debug {debugtext} {
# Debugging
global moo_debugging
if {$moo_debugging} {
putlog "\002-debug-\002 \037$debugtext"
}
}
##############################################################################

proc put_moolog {debugtext} {
putlog "\002-!-\002 \037$debugtext"
}
##############################################################################

proc moo_modechange {nick uhost hand chan req_mode rest} {

### Check if user is known

   if {$hand == "*"} {
      err $nick "You have no rights."
      put_debug "peon mode change attempted, ignoring"
   return 0 }

### User is known, begin mode change procedure

   set tmp_change [string range $req_mode 0 0]
   set tmp_mode [string range $req_mode 1 1]
   set tmp_fullmode $tmp_change$tmp_mode
    
   if {![botisop $chan]==1} {
      err $nick "I don't have ops on $chan"
      return 0
   }

   if {$rest == ""} {
   return 0
   }

   set uhandle [string tolower [lindex $rest 0]]

   if {$tmp_mode == "v"} {
      if {($uhandle=="me") || ($uhandle=="meh")} {
         if {[moo_cando $nick $chan "VOICESELF" $nick]} {
            pushmode $chan $tmp_fullmode $nick
         } else {
            return 0
         }
      } else {
         if {[moo_cando $nick $chan "VOICEOTHERS" $uhandle]} {
            if {![onchan $uhandle $chan]} {
               err $nick "$uhandle is not on $chan"
               return 0
            } else {
               pushmode $chan $tmp_fullmode $uhandle
            }         
         } else {
            return 0
         }
      }
   }

   if {$tmp_mode == "o"} {
      if {($uhandle=="me") || ($uhandle=="meh")} {
         if {[moo_cando $nick $chan "OPSELF" $nick]} {
            pushmode $chan $tmp_fullmode $nick
         } else {
            return 0
         }
      } else {
         if {[moo_cando $nick $chan "OPOTHERS" $uhandle]} {
            if {![onchan $uhandle $chan]} {
               err $nick "$uhandle is not on $chan"
               return 0
            } else {
               pushmode $chan $tmp_fullmode $uhandle
            }         
         } else {
            return 0
         }
      }
   }

# end proccy
}

##############################################################################

proc moo_getstatus {nick channel flag} {
# Check whether a user has a certain flag
set tmp_uhandle [nick2hand $nick $channel]
if {[matchattr $tmp_uhandle $flag $channel]} {return "1"} else { return "0" }
}

##############################################################################

proc moo_getflag {nick chan} {
# Check whether a user can perform a certain action
# The returned string is case sensitive
# N can do everything M can do, M everything O can do, and so on

   set tmp_hand [nick2hand $nick $chan]

   if {$tmp_hand == "*"} {return "p"}
   if {[matchattr $tmp_hand b]} {return "b"}
   if {[matchattr $tmp_hand n]} {return "N"}
   if {[matchattr $tmp_hand |n $chan]} {return "n"}
   if {[matchattr $tmp_hand m]} {return "M"}
   if {[matchattr $tmp_hand |m $chan]} {return "m"}
   if {[matchattr $tmp_hand o]} {return "O"}
   if {[matchattr $tmp_hand |o $chan]} {return "o"}
   if {[matchattr $tmp_hand v]} {return "V"}
   if {[matchattr $tmp_hand |v $chan]} {return "v"}
   return "p"
}

##############################################################################

proc kick_user {nick uhost hand channel rest} {

   set uhandle [lindex $rest 0]

   if {![moo_cando $nick $channel "KICK" $uhandle]} {
      err $nick "Cannot comply!"
      return 0
   }
   
   if {[lrange $rest 1 end]!=""} { set k_reason [lrange $rest 1 end] } else {set k_reason none}

   put_moolog "<<KICK>> $hand kicked $uhandle on $channel , reason: $k_reason"
   putserv "KICK $channel $uhandle :\037Reason\037: \002$k_reason\002"
   return 1

# end proccy
}

##############################################################################

proc ban_user {nick uhost hand channel rest} {

   global lastban

   set uhandle [lindex $rest 0]

   if {![moo_cando $nick $channel "KICK" $uhandle]} {
      err $nick "Cannot comply!"
      return 0
   }
   
   if {[lrange $rest 1 end]!=""} { set b_reason [lrange $rest 1 end] } else {set b_reason "lamer"}

   put_moolog "<<BAN>> $hand banned $uhandle on $channel , reason: $b_reason"
   set badhost [getchanhost $uhandle $channel]
   set banmask "*!*[string range $badhost [string first "@" $badhost] end]"
   set lastban($channel) $banmask
   if {[isop $uhandle $channel]} {
   putserv "MODE $channel -o+b $uhandle $banmask"
   }
   putserv "MODE $channel +b $banmask"
   newchanban $channel $banmask $nick "Public Ban" 10 sticky
   putserv "KICK $channel $uhandle :\037Banned\037: \002$b_reason\002"
   return 1

# end proccy
}
##############################################################################

proc undo {nick chan} {

global lastban lastunban

   if {[info exists lastban($chan)]!=1} {
      err $nick "I can't remember the last ban!"
      return 0
   }

   if {[killchanban $chan $lastban($chan)]==0} {
      putserv "MODE $chan -b $lastban($chan)"
   }

   put_moolog "<<UNDO>> $lastban($chan) unbanned on $chan by $nick"

   set lastunban($chan) $lastban($chan)

}

##############################################################################
proc redo {nick chan} {

global lastban lastunban

   if {[info exists lastunban($chan)]!=1} {
      err $nick "I can't remember the last unban!"
      return 0
   }

   putserv "MODE $chan +b $lastunban($chan)"
   newchanban $chan $lastunban($chan) $nick "Public Ban" 10 sticky

   put_moolog "<<REDO>> $lastban($chan) rebanned on $chan by $nick"

   set lastban($chan) $lastunban($chan)

}
##############################################################################

proc moo_cando {nick chan command uhandle} {

global botnick

   set tmp_uf [moo_getflag $nick $chan]
   set tmp_vf [moo_getflag $uhandle $chan]

   if {$command == "KICK"} {
      if {($tmp_uf == "V") || ($tmp_uf == "v") || ($tmp_uf == "p")} {
         return 0
      }
      if {![botisop $chan]==1} {
         return 0 
      }
      if {![onchan $uhandle $chan]} {
         return 0 
      }
      if {$tmp_uf!="N"} {
         if {($tmp_vf=="b")||($uhandle==[string tolower $botnick])} {
            return 0
         }
      }
      if {($tmp_uf=="N")} {
         if {$tmp_vf=="N"} {
            return 0
         }
      }
      if {($tmp_uf=="n")} {
         if {($tmp_vf=="N") || ($tmp_vf=="n")} {
            return 0
         }
      }
      if {($tmp_uf=="M")} {
         if {($tmp_vf=="N") || ($tmp_vf=="n") || ($tmp_vf=="M")} {
            return 0
         }
      }
      if {($tmp_uf=="m")} {
         if {($tmp_vf=="N") || ($tmp_vf=="n") || ($tmp_vf=="M") || ($tmp_vf=="m")} {
            return 0
         }
      }
      if {($tmp_uf=="O")} {
         if {($tmp_vf=="N") || ($tmp_vf=="n") || ($tmp_vf=="M") || ($tmp_vf=="m") || ($tmp_vf=="O")} {
            return 0
         }
      }
      if {($tmp_uf=="o")} {
         if {($tmp_vf=="N") || ($tmp_vf=="n") || ($tmp_vf=="M") || ($tmp_vf=="m") || ($tmp_vf=="O") || ($tmp_vf=="o")} {
            return 0
         }
      }
      return 1
   }

   if {$command == "OPSELF"} {
      if {($tmp_uf == "V") || ($tmp_uf == "v") || ($tmp_uf == "p")} {
         return 0
      }
      return 1
   }

   if {$command == "OPOTHERS"} {
      if {($tmp_uf == "V") || ($tmp_uf == "v") || ($tmp_uf == "p")} {
         return 0
      }
      return 1
   }

   if {$command == "VOICESELF"} {
      if {$tmp_uf == "p"} {
         return 0
      }
      return 1
   }
   
   if {$command == "VOICEOTHERS"} {
      if {($tmp_uf == "V") || ($tmp_uf == "v") || ($tmp_uf == "p")} {
         return 0
      }
      return 1
   }

# end proccy
}
##############################################################################


##############################################################################
##############################################################################
putcmdlog "Loaded Moo Script $moo_scriptver $moo_scriptdate $moo_scriptcomment"
##############################################################################
